CON
{''Hardware version 2.11 - see diagram.
''
} 
 _clkmode       = xtal1 + pll16x                        ' use crystal x 16
 _xinfreq       = 5_000_000                             'with 5mhz crystal 
      
  DEV_SD_CLK        = 18
  DEV_SD_DI         = 19
  DEV_SD_DO         = 20                                 
  DEV_SPI_EN        = 21                               ''SPI Enable enumeration
  DEV_SPI_ADD0      = 22                               ''Device address 0 enumeration
  DEV_SPI_ADD1      = 23                               ''Device address 1 enumeration
  DEV_SPI_ADD_LE    = 24
  
  DEV_SPI_LCD_RES    = 0                 ''Device id for LCD reset
  DEV_SPI_SDC_CS     = 1
  DEV_SPI_TSC_CS     = 2
  DEV_SPI_EXT_CS     = 3  
 DEV_SPI_EXT_POT_CS  = 0
 DEV_SPI_EXT_SW_CS   = 1
                      
  BGCOLOR                       = $ffff
  TXTCOLOR                      = $0000
   Pressed                       = 1  
   NotPressed                    = 0
faderUpBtnBound                 = 499     ''y < 499
faderDnBtnBound                 = 3700    ''y > 3699                  3200, 1600, 320
fadertouchoffset                = 320         ''3375 < y < 825  range of 2550 makes e
 
VAR
 long Screen_Buffer, CRbuffer
   long BackgroundColor, ActiveTextColor, stringptr[65]
   BYTE Fader0[3], Fader1[3], Fader2[3], Fader3[3], FaderPOS, NewFaderValue, OldValue              'FaderOrentation holds 0 for landscape, portrait not enabled 
  word Button0[5], Button1[5], Button2[5], Button3[5], Button4[5], Button5[5],  ButtonX, ButtonY, ButtonState, OldState
      WORD NotPressedBGC,NotPressedATC,PressedBGC,PressedATC, ButtonName, ButtonReg                       'ButtonGroup,oldButtonGroup,faderOrentation,
OBJ pfw :"PropFont_asmDone"
     wait : "timing"  
     pst : "parallax serial terminal"
     spi : "spi_asm"   
PUB BOOT   | f                       'bootstrap, initalizes pins, then starts pst, init display, start asm, clear screen and display hello world
  dirA[DEV_SPI_ADD0]   := 1             'makes address 0 and 1          
  dirA[DEV_SPI_ADD1]   := 1             'outputs
  dirA[DEV_SPI_EN]     := 1              'and enable an output as well
  OUTA[DEV_SPI_ADD1..DEV_SPI_ADD0] := 3
  OUTA[DEV_SPI_EN]     := 1             'Disable - Reset Screen
   'wait.pause1s(5)                               
   'PST_Init                         'Start Parallax Serial Terminal
BackgroundColor := $ffe0
ActiveTextColor := %0000  
 long[@Screen_Buffer]          := $ffff                        'make sure screen buffer does not equal 0  
  pfw.Start(@Long[@Screen_Buffer])                          'Start Asm Driver, needs to be changed to pass screen buffer from top object
    spi.start(3,0)
    
   '' pst.newline                               
   ''pst.str(string("Starting Asm"))             'Talk to human
   ''pst.newline
  dirA[DEV_SPI_EN]      := 1   
  OUTA[DEV_SPI_EN]       := 1             'Disable - Reset Screen
  dirA[DEV_SPI_ADD0]   := 1             'makes address 0 and 1          
  dirA[DEV_SPI_ADD1]   := 1             'outputs
    ButtonReg := $FFFF
    SendSwitch(ButtonReg)
   pfw.ClearScreen(BackgroundColor)            'Draw White Screen with asm
SetBtnColors(BackgroundColor,ActiveTextColor)
  faderinit


  buttoninit
    repeat 
       LCD_Menu
      
PUB LCD_Menu | data, tmpx, tmpy, f,b
      pfw.clearscreen(backgroundcolor)
        pfw.WriteActiveCr("F", 0, 8, 0, 0, BackgroundColor, ActiveTextColor, 1)
    pfw.WriteNextActiveCr("o")
    pfw.WriteNextActiveCr("n")
    pfw.WriteNextActiveCr("t")
    'pfw.WriteNextActiveCr(" ")
        pfw.WriteActiveCr("T", 32, 8, 0, 0, BackgroundColor, ActiveTextColor, 1) 
    pfw.WriteNextActiveCr("e")
    pfw.WriteNextActiveCr("s")
    pfw.WriteNextActiveCr("t")

        pfw.WriteActiveCr("F", 0, 7*15, 0, 0, BackgroundColor, ActiveTextColor, 1)
    pfw.WriteNextActiveCr("a")
    pfw.WriteNextActiveCr("d")
    pfw.WriteNextActiveCr("e")
    pfw.WriteNextActiveCr("r")
    'pfw.WriteNextActiveCr(" ")
        pfw.WriteActiveCr("T", 32, 7 * 16, 0, 0, BackgroundColor, ActiveTextColor, 1) 
    pfw.WriteNextActiveCr("e")
    pfw.WriteNextActiveCr("s")
    pfw.WriteNextActiveCr("t")

        pfw.WriteActiveCr("B", 0, 14*15, 0, 0, BackgroundColor, ActiveTextColor, 1)
    pfw.WriteNextActiveCr("u")
    pfw.WriteNextActiveCr("t")
    pfw.WriteNextActiveCr("t")
    pfw.WriteNextActiveCr("o")
    pfw.WriteNextActiveCr("n")    
    'pfw.WriteNextActiveCr(" ")
        pfw.WriteActiveCr("T", 32, 14 * 16, 0, 0, BackgroundColor, ActiveTextColor, 1) 
    pfw.WriteNextActiveCr("e")
    pfw.WriteNextActiveCr("s")
    pfw.WriteNextActiveCr("t")
    Data := TSWait
     tmpx := data & $0000_FFFF
     tmpy := data >> 16
      if tmpx > 2800
        if  tmpy > 2800   
           FontTest  
        elseif (1700 < tmpy) and (tmpy  <  2700)
          startWindow
          repeat
            FaderT
        elseif  (600  < tmpy) and (tmpy   < 1600)
                         
Pub StartWindow | f, b
           pfw.clearscreen(backgroundcolor)
            repeat f from 0 to 3
              getfader(f)
              drawfader
            repeat b from 0 to 5
              getbutton(b)
              drawbutton(b)
               
PUB PST_Init  | PstCog                                       ''Starts Parallax Serial Terminal for debugging.
  PstCog := (pst.Start(115200) -1)                             '' returns the cog pst started in
  pst.Str(String("Parallax Serial Terminal started in cog "))  ''  talk to human
  pst.Dec(PstCog)                                              '' displays cog on PST                                                  ''
  wait.pause1s(1)

PUB FontTest
pfw.clearscreen(backgroundcolor)
SizeTest
 TSWait
PUB FaderT  | data, tmpx, tmpy, f, b
repeat
   b := 6
   f := 4
  data := tswait
    tmpx := data & $0000_FFFF
    tmpy := data >> 16
   if  tmpx > 3200  
     f := 0  
   elseif ( 2425 < tmpx) and (tmpx  < 3199 )
     f := 1       
   elseif  ( 1651 < tmpx) and (tmpx   < 2425) 
     f := 2       
   elseif  (1000  < tmpx) and (tmpx   < 1650 )
     f := 3
   elseif  (400 < tmpx)   and   (tmpx < 800 )                  
     if     (3400 < tmpy)  and   (tmpy <   3700)
       b := 0
     elseif (2900 < tmpy)  and   (tmpy <   3200)
        b := 1
     elseif (2200 < tmpy) and    (tmpy <   2500)
        b := 2
     elseif (1650 < tmpy) and    (tmpy <   1900)
         b := 3
     elseif (1000 < tmpy) and    (tmpy <   1300)
         b := 4
     elseif (500  < tmpy)  and   (tmpy <   800)
         b := 5
     else
       return

  if f <> 4
   if tmpy < faderUpBtnBound
     getfader(f)
      OldValue := NewFaderValue
      NewFaderValue := (NewFaderValue +1) <# 255
      setfader(f)
      updatefader(f)
   elseif tmpy > faderDnBtnBound     
      getfader(f)
      OldValue := NewFaderValue
      NewFaderValue := (NewFaderValue - 1) #> 0
      setfader(f)
      updatefader(f)
   elseif tmpy < 1999
     getfader(f)
      OldValue := NewFaderValue
      NewFaderValue := (NewFaderValue + 10) <# 255  
      setfader(f)
      updatefader(f)
   elseif tmpy > 2000     
      getfader(f)
      OldValue := NewFaderValue
      NewFaderValue := (NewFaderValue - 10) #> 09
      setfader(f)
      updatefader(f)                         
  elseif b <> 6
   getbutton(b)
   oldstate := buttonstate
   !buttonstate
   setbutton(b)
     updatebuttons
     wait.pause1ms(250)
PUB SizeTest
    pfw.WriteActiveCr("L", 0, 0, 0, 0, BackgroundColor, ActiveTextColor, 1)    
    pfw.WriteNextActiveCr("a")
    pfw.WriteNextActiveCr("r")
    
    pfw.WriteNextActiveCr("g")
    pfw.WriteNextActiveCr("e")
    pfw.WriteNextActiveCr(" ")
    pfw.WriteNextActiveCr("F")
    pfw.WriteNextActiveCr("o")
    pfw.WriteNextActiveCr("n")
    pfw.WriteNextActiveCr("t")

    pfw.WriteActiveCr("S", 32, 0, 0, 0, BackgroundColor, ActiveTextColor, 2)    
    pfw.WriteNextActiveCr("m")
    pfw.WriteNextActiveCr("a")
    pfw.WriteNextActiveCr("l")
    pfw.WriteNextActiveCr("l")
    pfw.WriteNextActiveCr(" ")
    pfw.WriteNextActiveCr("F")
    pfw.WriteNextActiveCr("o")
    pfw.WriteNextActiveCr("n")
    pfw.WriteNextActiveCr("t")
PUB HelloWorld
    pfw.WriteActiveCr("H", 0, 0, 0, 0, BackgroundColor, ActiveTextColor, 1)    
    pfw.WriteNextActiveCr("e")
    pfw.WriteNextActiveCr("l")
    pfw.WriteNextActiveCr("l")
    pfw.WriteNextActiveCr("o")
    pfw.WriteNextActiveCr(" ")
    pfw.WriteNextActiveCr("W")
    pfw.WriteNextActiveCr("o")
    pfw.WriteNextActiveCr("r")
    pfw.WriteNextActiveCr("l")
    pfw.WriteNextActiveCr("d")
  tswait
pub deadend                                                               'loop for testing
  repeat                                                                             'endlessly wait
    repeat
     waitcnt(2_000 + cnt)

PUB SetBtnColors(BGC,ATC)                  
  NotPressedBGC                 := BGC
  NotPressedATC                 := ATC
  PressedBGC                    := ATC
  PressedATC                    := BGC
PUB ButtonInit | b
Button0[0] := 1                         'set bit3 to disable on startup
Button0[1] := 206
Button0[2] := 78
Button0[3] := 1
Button0[4] := 0

Button1[0] := 54
Button1[1] := 206
Button1[2] := 66
Button1[3] := 1
Button1[4] := 0

Button2[0] := 108
Button2[1] := 206
Button2[2] := 209
Button2[3] := 1
Button2[4] := 0

Button3[0] := 161
Button3[1] := 206
Button3[2] := 209
Button3[3] := 1
Button3[4] := 0  

Button4[0] := 216
Button4[1] := 206
Button4[2] := 66
Button4[3] := 1
Button4[4] := 0  

Button5[0] := 271
Button5[1] := 206
Button5[2] := 78
Button5[3] := 1
Button5[4] := 0  
 
PUB GetButton(Button)  
  case Button
    0: ButtonX     := Button0[0]
       ButtonY     := Button0[1]
       ButtonName  := Button0[2]
       ButtonState := Button0[3] 
       OldState    := Button0[4]
       
    1: ButtonX     := Button1[0]
       ButtonY     := Button1[1]
       ButtonName  := Button1[2]
       ButtonState := Button1[3] 
       OldState    := Button1[4]
        
    2: ButtonX     := Button2[0]
       ButtonY     := Button2[1]
       ButtonName  := Button2[2]
       ButtonState := Button2[3] 
       OldState    := Button2[4]
        
    3: ButtonX     := Button3[0]
       ButtonY     := Button3[1]
       ButtonName  := Button3[2]
       ButtonState := Button3[3] 
       OldState    := Button3[4]
       
    4: ButtonX     := Button4[0]
       ButtonY     := Button4[1]
       ButtonName  := Button4[2]
       ButtonState := Button4[3] 
       OldState    := Button4[4]
       
    5: ButtonX     := Button5[0]
       ButtonY     := Button5[1]
       ButtonName  := Button5[2]
       ButtonState := Button5[3] 
       OldState    := Button5[4]  
       
PUB SetButton(Button)  | btn
 case Button
    0:  Button0[3]        := ButtonState 
        Button0[4]        := OldState        
    1:  Button1[3]        := ButtonState
        Button1[4]        := OldState        
    2:  Button2[3]        := ButtonState 
        Button2[4]        := OldState       
    3:  Button3[3]        := ButtonState
        Button3[4]        := OldState        
    4:  Button4[3]        := ButtonState
        Button4[4]        := OldState        
    5:  Button5[3]        := ButtonState
        Button5[4]        := OldState
          
PUB DrawButton(Button) | x, y 
 if ButtonState == Pressed
  pfw.WriteActiveCr(1, ButtonY, ButtonX, 0, 0, PressedBGC, PressedATC, 1)
    pfw.WriteNextActiveCr(ButtonName)
  pfw.WriteNextActiveCr(9)
 else
  pfw.WriteActiveCr(1, ButtonY, ButtonX, 0, 0, NotPressedBGC, NotPressedATC,1)
    pfw.WriteNextActiveCr(ButtonName)
  pfw.WriteNextActiveCr(9)

PUB UpdateButtons | x, y, b
  ButtonReg := (Button5[3]<< 5)+ (Button4[3] << 4) + (Button3[3] << 3) + (Button2[3] << 2) + (Button1[3] << 1) + Button0[3]
  SendSwitch(ButtonReg)
repeat b from 0 to 5
getbutton(b)
if ButtonState <> OldState

   OldState := ButtonState  
 if ButtonState == Pressed
  pfw.WriteActiveCr(1, ButtonY, ButtonX, 0, 0, PressedBGC, PressedATC,1)
    pfw.WriteNextActiveCr(ButtonName)
  pfw.WriteNextActiveCr(9)
 else
  pfw.WriteActiveCr(1, ButtonY, ButtonX, 0, 0, NotPressedBGC, NotPressedATC,1)
    pfw.WriteNextActiveCr(ButtonName)
  pfw.WriteNextActiveCr(9)
    
PUB FaderInit | F , b
Fader0[0] := 1
Fader0[1] := 1
Fader0[2] := 2

Fader1[0] := 1
Fader1[1] := 1
Fader1[2] := 54

Fader2[0] := 1
Fader2[1] := 1
Fader2[2] := 106

Fader3[0] := 1
Fader3[1] := 1
Fader3[2] := 161

PUB SetFader(FaderNumber)
  case FaderNumber
    0: Fader0[0]  := NewFaderValue
       Fader0[1]  := OldValue
       Fader0[2]  := faderpos
       
    1: Fader1[0]  := NewFaderValue 
       Fader1[1]  := OldValue
       Fader1[2]  := faderpos
       
    2: Fader2[0]  := NewFaderValue
       Fader2[1]  := OldValue
       Fader2[2]  := faderpos
       
    3: Fader3[0]  := NewFaderValue
       Fader3[1]  :=OldValue
       Fader3[2]  := faderpos
      
PUB GetFader(FaderNumber)
 case FaderNumber
    0: NewFaderValue :=  Fader0[0]
       OldValue :=  Fader0[1]
       faderpos :=  Fader0[2]
       
    1: NewFaderValue :=  Fader1[0]
       OldValue :=  Fader1[1]
       faderpos :=  Fader1[2]
       
    2: NewFaderValue :=  Fader2[0]
       OldValue :=  Fader2[1]
       faderpos :=  Fader2[2]
       
    3: NewFaderValue :=  Fader3[0]
       OldValue :=  Fader3[1]
       faderpos :=  Fader3[2]
      
PUB updatefader(f) 'layer 2            
if OldValue<> NewFaderValue
     SendPot(F,NewFaderValue)
    pfw.WriteActiveCr(6, faderpos, 2,  4, 0, BackgroundColor, ActiveTextColor, 1)
    pfw.WriteActiveCr(7, faderpos, 301, 4, 0, BackgroundColor, ActiveTextColor, 1)
  
   pfw.WriteActiveCr(32, faderpos, OldValue + 24, 4, 3, BackgroundColor, ActiveTextColor, 1)
   pfw.WriteActiveCr(14, faderpos, NewFaderValue + 24, 4, 4, BackgroundColor, ActiveTextColor, 1)
     oldvalue := NewfaderValue
PUB DrawFader |index                'layer 1

  pfw.WriteActiveCr(1, faderpos, 0, 0, 0, BackgroundColor, ActiveTextColor, 1)
  pfw.WriteActiveCr(9, faderpos, 7, 0, 0, BackgroundColor, ActiveTextColor, 1)
   
     REPEAT 18
       pfw.WriteNextActiveCr(13)
    
    pfw.WriteActiveCr(1, faderpos, 297, 0, 0, BackgroundColor, ActiveTextColor, 1)
    pfw.WriteActiveCr(9, faderpos, 304, 0, 0, BackgroundColor, ActiveTextColor, 1)

    pfw.WriteActiveCr(6, faderpos, 2, 3, 0, BackgroundColor, ActiveTextColor, 1)
    pfw.WriteActiveCr(7, faderpos, 301, 3, 0, BackgroundColor, ActiveTextColor, 1)
  
    pfw.WriteActiveCr(32, faderpos, OldValue + 24, 5, 4, BackgroundColor, ActiveTextColor, 1)
    pfw.WriteActiveCr(14, faderpos, NewFaderValue + 24, 4, 4, BackgroundColor, ActiveTextColor, 1)

PUB TSWait  | yval, xval,x,y
  Enable_Touch       ''Old format was      OUTA[TS_CS] := 0     ' enable the touch screen
'SPI.start(3,0)                                      ' delay,state     Already running?
  'Shiftout = data,clock,mode,bits,value
  'shiftin = data,clock,mode,bits
  'SPI read S, A2, A1, A0, Mode, SER, PD1, PD0
  '         1  0   0   1    1     0    0    0
  ' MSB first
  ' 001 is X
  ' 101 is Y
   repeat
      'pst.clear
      SPI.SHIFTOUT(DEV_SD_DI, DEV_SD_CLK, 5, 8 , %1101_0000)  ' reads x from  500 to 3700  (off < 500 )
      xval := SPI.SHIFTIN(DEV_SD_DO, DEV_SD_CLK,2, 12)
      SPI.SHIFTOUT(DEV_SD_DI, DEV_SD_CLK, 5, 8 , %1001_0000)  ' reads y from 400 to 3800 (off > 3800 ) 
      yval := SPI.SHIFTIN(DEV_SD_DO,DEV_SD_CLK,2, 12)
      'pst.Dec(xval)
      'pst.newline
       'pst.Dec(yval)
       if xval <>  0
         result := xval + (yval << 16)         
         Disable_Touch ''Old format was   OUTA[TS_CS] := 1     ' disable the touch screen     
        'SPI.Stop
        return
      wait.pause1ms(10)
 
PRI Enable_Touch
  OUTA[DEV_SPI_ADD1..DEV_SPI_ADD0] := DEV_SPI_TSC_CS                              
  OUTA[DEV_SPI_EN] := 0                        ' 
PRI Disable_Touch                                                                                  
  OUTA[DEV_SPI_EN] := 1  

PRI SendPot(Address, Data) | D
'SPI.Start(3,0)                                 
      address <<= 8
      d := data + address
      Set_Spi_Ext_Address(DEV_SPI_EXT_POT_CS)
      outa[DEV_SPI_EN] := 0 
      SPI.SHIFTOUT(DEV_SD_DO, DEV_SD_CLK, 5, 11, d)
      outa[DEV_SPI_EN] := 1
'spi.stop
PRI  SendSwitch(data)
'SPI.Start(3,0)
      Set_Spi_Ext_Address(DEV_SPI_EXT_SW_CS)
      SPI.SHIFTOUT(DEV_SD_DO, DEV_SD_CLK, 5, 8, data)
      StrobeCS
'Spi.Stop
PUB Set_Spi_Ext_Address(Ext_Spi_Address)
  OUTA[DEV_SPI_ADD1..DEV_SPI_ADD0] := DEV_SPI_EXT_CS
  wait.pause1ms(1)
  OUTA[DEV_SPI_ADD_LE] := 0
   wait.pause1ms(1)
  SPI.SHIFTOUT(DEV_SD_DO, DEV_SD_CLK, 5, 3, Ext_Spi_Address)
  wait.pause1ms(1)
  OUTA[DEV_SPI_ADD_LE] := 1
  wait.pause1ms(1)
  
PUB StrobeCS
   OUTA[DEV_SPI_EN] := 0
   wait.pause1ms(10)
   OUTA[DEV_SPI_EN] := 1 